package jp.mosp.payroll.payment.vo;

import java.util.Date;

import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.base.PayrollVo;

/**
 * 給与計算開始画面に関する情報を扱う。
 */
public class EndCalcVo extends PayrollVo {
	
	private static final long serialVersionUID = -7478499827596316326L;
	
	// フィールド
	Date calcDate;
	
	// 画面モード
	private int mode;
	
	/**
	 * {@link PayrollVo#PayrollVo()}を実行する。
	 */
	public EndCalcVo() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#setSubTitle()
	 */
	@Override
	protected void setSubTitle() {
		super.setSubTitle();
		subTitle = getName("P_PAYROLL") + getName("C_END");
		addAryMenu("P1001", getName("P_PAYMENT") +
				getName("P_CALCULATE") + getName("C_MENU") + getName("C_TO"));
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#getDirectJs(Class)
	 */
	@Override
	public String getDirectJs(Class<?> cls) throws IllegalAccessException {
		StringBuffer sb = new StringBuffer();
		sb.append(super.getDirectJs(cls));
		sb.append("var MODE = ");
		sb.append(mode);
		sb.append(";");
		return sb.toString();
	}
	
	/**
	 * 計算年月を取得する。
	 * @return 計算年月
	 */
	public Date getCalcDate() {
		return getDateField(calcDate);
	}

	/**
	 * 計算年月を設定する。
	 * @param calcDate 設定する計算年月
	 */
	public void setCalcDate(Date calcDate) {
		this.calcDate = getDateField(calcDate);
	}

	/**
	 * 計算年月(文字列)を取得する。
	 * @return 計算年月(文字列)
	 */
	public String getStrCalcDate() {
		return MospUtility.getDateString(calcDate, PayrollConst.FORMAT_YEAR_MONTH);
	}
	
	/**
	 * 画面モードを設定する。<br><br>
	 * 0:通常、1：計算中無し、2：終了処理後
	 * @param mode 設定する画面モード
	 */
	public void setMode(int mode) {
		this.mode = mode;
	}

}
